diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/random-variable-stream.cc ns-3.38/src/core/model/random-variable-stream.cc
--- ns-3.37/src/core/model/random-variable-stream.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/random-variable-stream.cc	2023-03-16 20:54:23.592868600 -0700
@@ -102,6 +102,13 @@
     return m_isAntithetic;
 }
 
+uint32_t
+RandomVariableStream::GetInteger()
+{
+    NS_LOG_FUNCTION(this);
+    return static_cast<uint32_t>(GetValue());
+}
+
 void
 RandomVariableStream::SetStream(int64_t stream)
 {
@@ -216,7 +223,7 @@
 UniformRandomVariable::GetInteger()
 {
     NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_min, m_max + 1);
+    return static_cast<uint32_t>(GetValue(m_min, m_max + 1));
 }
 
 NS_OBJECT_ENSURE_REGISTERED(ConstantRandomVariable);
@@ -270,13 +277,6 @@
     return GetValue(m_constant);
 }
 
-uint32_t
-ConstantRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_constant);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(SequentialRandomVariable);
 
 TypeId
@@ -355,7 +355,7 @@
     NS_LOG_FUNCTION(this);
     if (!m_isCurrentSet)
     {
-        // Start the sequence at its minimium value.
+        // Start the sequence at its minimum value.
         m_current = m_min;
         m_isCurrentSet = true;
     }
@@ -374,13 +374,6 @@
     return r;
 }
 
-uint32_t
-SequentialRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue();
-}
-
 NS_OBJECT_ENSURE_REGISTERED(ExponentialRandomVariable);
 
 TypeId
@@ -462,13 +455,6 @@
     return GetValue(m_mean, m_bound);
 }
 
-uint32_t
-ExponentialRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_mean, m_bound);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(ParetoRandomVariable);
 
 TypeId
@@ -568,13 +554,6 @@
     return GetValue(m_scale, m_shape, m_bound);
 }
 
-uint32_t
-ParetoRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_scale, m_shape, m_bound);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(WeibullRandomVariable);
 
 TypeId
@@ -672,13 +651,6 @@
     return GetValue(m_scale, m_shape, m_bound);
 }
 
-uint32_t
-WeibullRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_scale, m_shape, m_bound);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(NormalRandomVariable);
 
 const double NormalRandomVariable::INFINITE_VALUE = 1e307;
@@ -804,13 +776,6 @@
     return GetValue(m_mean, m_variance, m_bound);
 }
 
-uint32_t
-NormalRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_mean, m_variance, m_bound);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(LogNormalRandomVariable);
 
 TypeId
@@ -934,13 +899,6 @@
     return GetValue(m_mu, m_sigma);
 }
 
-uint32_t
-LogNormalRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_mu, m_sigma);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(GammaRandomVariable);
 
 TypeId
@@ -1055,13 +1013,6 @@
     return beta * d * v;
 }
 
-uint32_t
-GammaRandomVariable::GetInteger(uint32_t alpha, uint32_t beta)
-{
-    NS_LOG_FUNCTION(this << alpha << beta);
-    return static_cast<uint32_t>(GetValue(alpha, beta));
-}
-
 double
 GammaRandomVariable::GetValue()
 {
@@ -1069,13 +1020,6 @@
     return GetValue(m_alpha, m_beta);
 }
 
-uint32_t
-GammaRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_alpha, m_beta);
-}
-
 double
 GammaRandomVariable::GetNormalValue(double mean, double variance, double bound)
 {
@@ -1213,13 +1157,6 @@
     return GetValue(m_k, m_lambda);
 }
 
-uint32_t
-ErlangRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_k, m_lambda);
-}
-
 double
 ErlangRandomVariable::GetExponentialValue(double mean, double bound)
 {
@@ -1340,13 +1277,6 @@
     return GetValue(m_mean, m_min, m_max);
 }
 
-uint32_t
-TriangularRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_mean, m_min, m_max);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(ZipfRandomVariable);
 
 TypeId
@@ -1437,13 +1367,6 @@
     return GetValue(m_n, m_alpha);
 }
 
-uint32_t
-ZipfRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_n, m_alpha);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(ZetaRandomVariable);
 
 TypeId
@@ -1525,13 +1448,6 @@
     return GetValue(m_alpha);
 }
 
-uint32_t
-ZetaRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue(m_alpha);
-}
-
 NS_OBJECT_ENSURE_REGISTERED(DeterministicRandomVariable);
 
 TypeId
@@ -1563,7 +1479,13 @@
 }
 
 void
-DeterministicRandomVariable::SetValueArray(double* values, std::size_t length)
+DeterministicRandomVariable::SetValueArray(const std::vector<double>& values)
+{
+    SetValueArray(values.data(), values.size());
+}
+
+void
+DeterministicRandomVariable::SetValueArray(const double* values, std::size_t length)
 {
     NS_LOG_FUNCTION(this << values << length);
     // Delete any values currently set.
@@ -1598,13 +1520,6 @@
     return m_data[m_next++];
 }
 
-uint32_t
-DeterministicRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return (uint32_t)GetValue();
-}
-
 NS_OBJECT_ENSURE_REGISTERED(EmpiricalRandomVariable);
 
 // ValueCDF methods
@@ -1661,13 +1576,6 @@
     return prev;
 }
 
-uint32_t
-EmpiricalRandomVariable::GetInteger()
-{
-    NS_LOG_FUNCTION(this);
-    return static_cast<uint32_t>(GetValue());
-}
-
 bool
 EmpiricalRandomVariable::PreSample(double& value)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/realtime-simulator-impl.cc ns-3.38/src/core/model/realtime-simulator-impl.cc
--- ns-3.37/src/core/model/realtime-simulator-impl.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/realtime-simulator-impl.cc	2023-03-16 20:54:23.592868600 -0700
@@ -266,7 +266,7 @@
         //
         // It's easiest to understand if you just consider a short tsDelay that only
         // requires a SpinWait down in the synchronizer.  What will happen is that
-        // whan Synchronize calls SpinWait, SpinWait will look directly at its
+        // when Synchronize calls SpinWait, SpinWait will look directly at its
         // condition variable.  Note that we set this condition variable to false
         // inside the critical section above.
         //
@@ -811,7 +811,7 @@
 }
 
 void
-RealtimeSimulatorImpl::SetSynchronizationMode(enum SynchronizationMode mode)
+RealtimeSimulatorImpl::SetSynchronizationMode(SynchronizationMode mode)
 {
     NS_LOG_FUNCTION(this << mode);
     m_synchronizationMode = mode;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/simple-ref-count.h ns-3.38/src/core/model/simple-ref-count.h
--- ns-3.37/src/core/model/simple-ref-count.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/simple-ref-count.h	2023-03-16 20:54:23.596868500 -0700
@@ -40,7 +40,7 @@
  * \ingroup ptr
  * \brief Empty class, used as a default parent class for SimpleRefCount
  */
-class empty
+class Empty
 {
 };
 
@@ -66,7 +66,7 @@
  *      common C++ template pattern whose name is CRTP (Curiously
  *      Recursive Template Pattern)
  * \tparam PARENT \explicit The typename of the parent of this template.
- *      By default, this typename is "'ns3::empty'" which is an empty
+ *      By default, this typename is "'ns3::Empty'" which is an empty
  *      class: compilers which implement the EBCO optimization (empty
  *      base class optimization) will make this a no-op
  * \tparam DELETER \explicit The typename of a class which implements
@@ -76,7 +76,7 @@
  *
  * Interesting users of this class include ns3::Object as well as ns3::Packet.
  */
-template <typename T, typename PARENT = empty, typename DELETER = DefaultDeleter<T>>
+template <typename T, typename PARENT = Empty, typename DELETER = DefaultDeleter<T>>
 class SimpleRefCount : public PARENT
 {
   public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/string.cc ns-3.38/src/core/model/string.cc
--- ns-3.37/src/core/model/string.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/string.cc	2023-03-16 20:54:23.596868500 -0700
@@ -30,4 +30,27 @@
 ATTRIBUTE_CHECKER_IMPLEMENT_WITH_NAME(String, "std::string");
 ATTRIBUTE_VALUE_IMPLEMENT_WITH_NAME(std::string, String);
 
+StringVector
+SplitString(const std::string& str, const std::string& delim)
+{
+    std::vector<std::string> result;
+    std::string token;
+    std::size_t pos{0};
+    do
+    {
+        std::size_t next = str.find(delim, pos);
+        std::string token{str.substr(pos, next - pos)};
+        result.push_back(token);
+        if (next < str.size())
+        {
+            pos = next + delim.size();
+        }
+        else
+        {
+            pos = str.size() + 1;
+        }
+    } while (pos <= str.size());
+    return result;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/string.h ns-3.38/src/core/model/string.h
--- ns-3.37/src/core/model/string.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/string.h	2023-03-16 20:54:23.596868500 -0700
@@ -22,6 +22,7 @@
 #include "attribute-helper.h"
 
 #include <string>
+#include <vector>
 
 /**
  * \file
@@ -32,6 +33,19 @@
 namespace ns3
 {
 
+/** Return type of SplitString. */
+using StringVector = std::vector<std::string>;
+
+/**
+ * Split a string on a delimiter.
+ * The input string is ummodified.
+ * \param [in] str The string.
+ * \param [in] delim The delimiter.
+ * \returns A vector of the components of \p str which were separated
+ * by \p delim.
+ */
+StringVector SplitString(const std::string& str, const std::string& delim);
+
 //  Additional docs for class StringValue:
 /**
  * Hold variables of type string
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/system-path.cc ns-3.38/src/core/model/system-path.cc
--- ns-3.37/src/core/model/system-path.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/system-path.cc	2023-03-16 20:54:23.596868500 -0700
@@ -19,12 +19,12 @@
 #include "system-path.h"
 
 #include "assert.h"
+#include "environment-variable.h"
 #include "fatal-error.h"
 #include "log.h"
+#include "string.h"
 
 #include <algorithm>
-#include <cstdlib> // getenv
-#include <cstring> // strlen
 #include <ctime>
 #include <regex>
 #include <sstream>
@@ -61,6 +61,7 @@
 #endif
 
 #ifdef __linux__
+#include <cstring>
 #include <unistd.h>
 #endif
 
@@ -257,19 +258,8 @@
 Split(std::string path)
 {
     NS_LOG_FUNCTION(path);
-    std::list<std::string> retval;
-    std::string::size_type current = 0;
-    std::string::size_type next = 0;
-    next = path.find(SYSTEM_PATH_SEP, current);
-    while (next != std::string::npos)
-    {
-        std::string item = path.substr(current, next - current);
-        retval.push_back(item);
-        current = next + 1;
-        next = path.find(SYSTEM_PATH_SEP, current);
-    }
-    std::string item = path.substr(current, next - current);
-    retval.push_back(item);
+    std::vector<std::string> items = SplitString(path, SYSTEM_PATH_SEP);
+    std::list<std::string> retval(items.begin(), items.end());
     return retval;
 }
 
@@ -280,7 +270,7 @@
     std::string retval = "";
     for (std::list<std::string>::const_iterator i = begin; i != end; i++)
     {
-        if (*i == "")
+        if ((*i).empty())
         {
             // skip empty strings in the path list
             continue;
@@ -315,15 +305,13 @@
 MakeTemporaryDirectoryName()
 {
     NS_LOG_FUNCTION_NOARGS();
-    char* path = nullptr;
-
-    path = std::getenv("TMP");
-    if (!path || std::strlen(path) == 0)
+    auto [found, path] = EnvironmentVariable::Get("TMP");
+    if (!found)
     {
-        path = std::getenv("TEMP");
-        if (!path || std::strlen(path) == 0)
+        std::tie(found, path) = EnvironmentVariable::Get("TEMP");
+        if (!found)
         {
-            path = const_cast<char*>("/tmp");
+            path = "/tmp";
         }
     }
 
@@ -396,7 +384,7 @@
     auto tokens = Split(path);
     std::string file = tokens.back();
 
-    if (file == "")
+    if (file.empty())
     {
         // Last component was a directory, not a file name
         // We already checked that the directory exists,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/system-path.h ns-3.38/src/core/model/system-path.h
--- ns-3.37/src/core/model/system-path.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/system-path.h	2023-03-16 20:54:23.596868500 -0700
@@ -120,12 +120,12 @@
  *
  * The first part, "/tmp/" is the absolute path found by inspecting
  * the environment variables `TMP`and `TEMP`, in order. If neither
- * exists the hard-codes root path `/tmp/` is used.
+ * exists the hard-coded root path `/tmp/` is used.
  *
  * The directory name itself starts with the "ns3" identifier telling folks
  * who is making all of the temp directories.
  *
- * The next three number give the hour, minute and second, separated by
+ * The next three numbers give the hour, minute and second, separated by
  * periods.
  *
  * The final number is randomly generated, to avoid name collisions.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/system-wall-clock-ms.h ns-3.38/src/core/model/system-wall-clock-ms.h
--- ns-3.37/src/core/model/system-wall-clock-ms.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/system-wall-clock-ms.h	2023-03-16 20:54:23.596868500 -0700
@@ -32,21 +32,6 @@
 {
 
 /**
- * \ingroup core
- * \defgroup system System Services
- *
- * System-independent interfaces to operating system services:
- * files system, threading, wall clock time.
- *
- * Services provided:
- *
- *   - File and directory paths.
- *   - Thread primitives:  threads, conditional waits, mutex, critical sections.
- *   - Asynchronous input from a file descriptor.
- *   - Wall clock time.
- */
-
-/**
  * \ingroup system
  * \brief Measure elapsed wall clock time in milliseconds.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/test.cc ns-3.38/src/core/model/test.cc
--- ns-3.37/src/core/model/test.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/test.cc	2023-03-16 20:54:23.596868500 -0700
@@ -54,7 +54,7 @@
     //
     {
         double max = (std::fabs(x1) > std::fabs(x2)) ? x1 : x2;
-        (void)std::frexp(max, &exponent);
+        std::frexp(max, &exponent);
     }
 
     //
@@ -217,7 +217,7 @@
      *
      * \param [in] begin Iterator to the first TestCase to print.
      * \param [in] end Iterator to the end of the list.
-     * \param [in] printTestType Preprend the test type label if \c true.
+     * \param [in] printTestType Prepend the test type label if \c true.
      */
     void PrintTestNameList(std::list<TestCase*>::const_iterator begin,
                            std::list<TestCase*>::const_iterator end,
@@ -424,7 +424,7 @@
 {
     NS_LOG_FUNCTION(this << filename);
     const TestCase* current = this;
-    while (current != nullptr && current->m_dataDir == "")
+    while (current != nullptr && current->m_dataDir.empty())
     {
         current = current->m_parent;
     }
@@ -849,7 +849,7 @@
             // skip test
             continue;
         }
-        if (testName != "" && test->GetName() != testName)
+        if (!testName.empty() && test->GetName() != testName)
         {
             // skip test
             continue;
@@ -1007,7 +1007,7 @@
         argi++;
     }
     enum TestSuite::Type testType;
-    if (testTypeString == "")
+    if (testTypeString.empty())
     {
         testType = TestSuite::ALL;
     }
@@ -1040,7 +1040,7 @@
 
     std::list<TestCase*> tests = FilterTests(testName, testType, maximumTestDuration);
 
-    if (m_tempDir == "")
+    if (m_tempDir.empty())
     {
         m_tempDir = SystemPath::MakeTemporaryDirectoryName();
     }
@@ -1060,7 +1060,7 @@
     }
 
     std::ostream* os;
-    if (out != "")
+    if (!out.empty())
     {
         std::ofstream* ofs;
         ofs = new std::ofstream();
@@ -1083,11 +1083,17 @@
 
     // let's run our tests now.
     bool failed = false;
-    if (tests.size() == 0)
+    if (tests.empty())
     {
         std::cerr << "Error:  no tests match the requested string" << std::endl;
         return 1;
     }
+    else if (tests.size() > 1)
+    {
+        std::cerr << "Error:  tests should be launched separately (one at a time)" << std::endl;
+        return 1;
+    }
+
     for (std::list<TestCase*>::const_iterator i = tests.begin(); i != tests.end(); ++i)
     {
         TestCase* test = *i;
@@ -1128,7 +1134,7 @@
         }
     }
 
-    if (out != "")
+    if (!out.empty())
     {
         delete os;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/test.h ns-3.38/src/core/model/test.h
--- ns-3.37/src/core/model/test.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/test.h	2023-03-16 20:54:23.596868500 -0700
@@ -225,7 +225,7 @@
  * \brief Test that an actual and expected (limit) value are equal and
  * report if not.
  *
- * Check to see if the expected (lmit) value is equal to the actual
+ * Check to see if the expected (limit) value is equal to the actual
  * value found in a test case.  If the two values are equal nothing
  * happens, but if the comparison fails, an error is reported in a
  * consistent way.  EXPECT* macros do not return if an error is
@@ -1130,7 +1130,7 @@
     bool IsStatusSuccess() const;
 
     /**
-     * \brief Get the parent of this TestCsse.
+     * \brief Get the parent of this TestCase.
      *
      * \return A pointer to the parent of this test.
      */
@@ -1242,7 +1242,7 @@
     TestRunnerImpl* m_runner;          //!< Pointer to the TestRunner
     struct Result* m_result;           //!< Results data
     std::string m_name;                //!< TestCase name
-    enum TestDuration m_duration;      //!< TestCase duration
+    TestDuration m_duration;           //!< TestCase duration
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/time.cc ns-3.38/src/core/model/time.cc
--- ns-3.37/src/core/model/time.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/model/time.cc	2023-03-16 20:54:23.596868500 -0700
@@ -203,14 +203,14 @@
 Time::SetDefaultNsResolution()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static struct Resolution resolution;
+    static Resolution resolution;
     SetResolution(Time::NS, &resolution, false);
     return resolution;
 }
 
 // static
 void
-Time::SetResolution(enum Unit resolution)
+Time::SetResolution(Unit resolution)
 {
     NS_LOG_FUNCTION(resolution);
     SetResolution(resolution, PeekResolution());
@@ -218,7 +218,7 @@
 
 // static
 void
-Time::SetResolution(enum Unit unit, struct Resolution* resolution, const bool convert /* = true */)
+Time::SetResolution(Unit unit, Resolution* resolution, const bool convert /* = true */)
 {
     NS_LOG_FUNCTION(resolution);
     if (convert)
@@ -375,7 +375,7 @@
 
 // static
 void
-Time::ConvertTimes(const enum Unit unit)
+Time::ConvertTimes(const Unit unit)
 {
     std::unique_lock lock{g_markingMutex};
 
@@ -414,7 +414,7 @@
 }
 
 TimeWithUnit
-Time::As(const enum Unit unit /* = Time::AUTO */) const
+Time::As(const Unit unit /* = Time::AUTO */) const
 {
     return TimeWithUnit(*this, unit);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/timer.cc ns-3.38/src/core/model/timer.cc
--- ns-3.37/src/core/model/timer.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/model/timer.cc	2023-03-16 20:54:23.596868500 -0700
@@ -42,7 +42,7 @@
     NS_LOG_FUNCTION(this);
 }
 
-Timer::Timer(enum DestroyPolicy destroyPolicy)
+Timer::Timer(DestroyPolicy destroyPolicy)
     : m_flags(destroyPolicy),
       m_delay(FemtoSeconds(0)),
       m_event(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/timer.h ns-3.38/src/core/model/timer.h
--- ns-3.37/src/core/model/timer.h	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/model/timer.h	2023-03-16 20:54:23.596868500 -0700
@@ -121,7 +121,7 @@
      * \param [in] destroyPolicy the event lifetime management policies
      * to use for destroy events
      */
-    Timer(enum DestroyPolicy destroyPolicy);
+    Timer(DestroyPolicy destroyPolicy);
     ~Timer();
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/type-id.cc ns-3.38/src/core/model/type-id.cc
--- ns-3.37/src/core/model/type-id.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/model/type-id.cc	2023-03-16 20:54:23.596868500 -0700
@@ -430,7 +430,7 @@
         }
     }
 
-    struct IidInformation information;
+    IidInformation information;
     information.name = name;
     information.hash = hash;
     information.parent = 0;
@@ -1201,7 +1201,7 @@
 Ptr<const TraceSourceAccessor>
 TypeId::LookupTraceSourceByName(std::string name) const
 {
-    struct TraceSourceInformation info;
+    TraceSourceInformation info;
     return LookupTraceSourceByName(name, &info);
 }
 
